Subject: RE: [PATCH 15/16] Add device tree for Ebony

From: Benjamin Herrenschmidt <[email-masked]>
Date: Thu, 15 Feb 2007 08:42:40 +1100

> der an "soc" node at the same level.
> > 
> > A "soc" node is meant to contain SoC specific stuff like
> > clock registers or whatnot.  It typically wouldn't have
> > child nodes.
> 
> That's not what booting_without_of.txt says.  It says:
> 
>     The SOC node may contain child nodes for each SOC
>     device that the  platform uses.
> 
> All the dts files in arch/powerpc/boot/dts I've looked at have
> an soc node with a whole bunch of devices under it.

Wel, that was written by FSL not long ago :-)

> The current practice seems to be that an "soc" node contains
> all the on chip devices (regardless of the physical bus internal
> to the soc).

That's the current FSL practice yes. As I said, I'm not too fan of it. I
prefer a more precise representation of the internal bus layout.

> The device_type is typically things like "network" and "serial"
> which don't specify the programming model.   The compatible 
> property is used in driver selection. 

The device type specifies the programming model of the node for OF, that
is the set of words the driver will provide to OF. So that's something
we don't necessarily care much about for non-OF implementation but still
we should avoid going too far from that model either (after all,
somebody can very well want to use a real OF on a board with a SoC).

The device type is also used by the kernel in some areas. For example,
the spec specifies that PCI host controllers and P2P bridges have a
device-type of "pci" and the kernel relies heavily on that. Same for
ISA. It thus makes sense to continue that practice with other bus types.

Ben.